/****************************************************************************

                Copyright (c) 2008 Aleksej Kozlov

****************************************************************************/

#define INCL_WIN
#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include "test.h"
#include "..\merlinn.h"

ULONG cdecl SetAttr(void *objparam, char *fldid, ULONG id, ULONG ctrltype, char *value)
{
  char buffer[4096]; //樮 ணࠬ: ९   ᫥

  if(value && *value)
  {
    strcpy(buffer, fldid);
    strcat(buffer, " = ");
    strcat(buffer, value);
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buffer, "Set Attribute", 11111, MB_OK);
  }
  return 0;
}

ULONG cdecl SetBinAttr(void *objparam, char *fldid, ULONG id, ULONG ctrltype, char *value, ULONG valuesize)
{
  char buffer[4096]; //樮 ணࠬ: ९   ᫥
  char buf_num[16];

  if(value && valuesize)
  {
    strcpy(buffer, fldid);
    strcat(buffer, " = binary value, ");
    itoa(valuesize, buf_num, 10);
    strcat(buffer, buf_num);
    strcat(buffer, " bytes");
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buffer, "Set Binary Attribute", 11111, MB_OK);
  }
  return 0;
}

void main(void)
{
  HAB hab;
  HMQ hmq;
  QMSG qmsg;
  HWND hwnd;
  ULONG flStyle;
  MERLINNOTEBOOKINFO *notebookinfo;

  hab = WinInitialize(0);
  if(hab)
  {
    hmq = WinCreateMsgQueue(hab, 0);
    if(hmq)
    {
      //test usual dialog
      hwnd = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP, NULL, NULLHANDLE, IDD_DIALOG, NULL);
      if(hwnd)
      {
        if(MerlinRetrieveXml(&notebookinfo, "test1.xml", NULL, NULL, 0) != 0)
          WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Cannot read 'test1.xml'", "Error", 11111, MB_OK);
        else
        {
          MerlinInsertControls(notebookinfo, NULL, hwnd, 0, NULL, NULL, NULL);
          WinProcessDlg(hwnd);
          MerlinSaveControlsData(notebookinfo, NULL, hwnd, SetAttr, SetBinAttr);
          MerlinFree(notebookinfo);
        }
      }

/*
      //test dialog with notebook
      flStyle = FCF_STANDARD;
//::      hwnd = WinCreateStdWindow(HWND_DESKTOP, 0, &flStyle, NULL, "Merlin Notebook Test", 0, NULLHANDLE, 0, NULL);
      hwnd = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP, NULL, NULLHANDLE, IDD_DIALOG, NULL);
      if(hwnd)
      {
        if(MerlinRetrieveXml(&notebookinfo, "test2.xml", NULL, NULL, 0) != 0)
          WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Cannot read 'test2.xml'", "Error", 11111, MB_OK);
        else
        {
          MerlinInsertNotebook(notebookinfo, NULL, hwnd, ID_NOTEBOOK, NULL, NULL, NULL, NULL);
          WinProcessDlg(hwnd);
          MerlinSaveControlsData(notebookinfo, NULL, hwnd, SetAttr, SetBinAttr);
          MerlinFree(notebookinfo);
        }
      }
*/

      WinDestroyMsgQueue(hmq);
    }
    WinTerminate(hab);
  }
}
